unit GWDragDemo_Main;
{---------------------------------------------------------
Purpose: Demonstrates and exercises OLE Drag functionality using
         GWDragSource unit

Author:  Graham Wideman
         graham@wideman-one.com
         www.wideman-one.com

Revision History
----------------
98-07-20 GW V1.1 original (version sync'ed with GWDropDemo)
----------------------------------------------------------}


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ExtCtrls,
  GWDragSource, GWDragDemoAppInterface, Grids;

type
  TIDT_DisplayInfo = record
    Lb:  TLabel;
    Sh: TShape;
  end;

  Tfm_Main = class(TForm)
    MainMenu1: TMainMenu;
    m_File: TMenuItem;
    mi_Quit: TMenuItem;
    m_Help: TMenuItem;
    mi_About: TMenuItem;
    gb_IDragSource: TGroupBox;
    tx_DragSource: TEdit;
    tx_DragMe: TStaticText;
    bt_ShowMonitor: TButton;
    GroupBox3: TGroupBox;
    Label4: TLabel;
    lb_OKEffects: TLabel;
    Label7: TLabel;
    lb_DDDEffect: TLabel;
    Label9: TLabel;
    lb_DDD_Result: TLabel;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    lb_KeyState: TLabel;
    Label3: TLabel;
    lb_QCD_Result: TLabel;
    GroupBox2: TGroupBox;
    Label2: TLabel;
    lb_Effect: TLabel;
    Label5: TLabel;
    lb_GF_Result: TLabel;
    procedure mi_AboutClick(Sender: TObject);
    procedure mi_QuitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);

    procedure tx_DragMeMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure bt_ShowMonitorClick(Sender: TObject);
  private
    { Private declarations }
    FGWDragDemoAppInterface: TGWDragAppInterface;

  public
    { Public declarations }
    procedure ClearDeadMonitors;
  end;

var
  fm_Main: Tfm_Main;

implementation

uses ActiveX, fm_About, GWMonOLE;

{$R *.DFM}

//-------------------------------------------------
procedure Tfm_Main.FormCreate(Sender: TObject);
//-------------------------------------------------
Var
  S: string;
begin
  S := Caption;
  FGWDragDemoAppInterface := TGWDragDemoAppInterface.Create(Self, true);
  //FGWDragDemoAppInterface := TGWDragAppInterface.Create(Self, true); // tests generic version

  // Init other objects

  // Init our display
  Top := 100;
  Left := 100;

end;

//-------------------------------------------------
procedure Tfm_Main.FormDestroy(Sender: TObject);
//-------------------------------------------------
begin
  FGWDragDemoAppInterface.Destroy;
end;

//-------------------------------------------------
procedure Tfm_Main.mi_AboutClick(Sender: TObject);
//-------------------------------------------------
begin
  fm_AboutBox.Left := Left+ 100;
  fm_AboutBox.Top  := Top + 100;
  fm_AboutBox.ShowModal;
end;

//-------------------------------------------------
procedure Tfm_Main.mi_QuitClick(Sender: TObject);
//-------------------------------------------------
begin
  Application.Terminate;
end;

{-----------------------------------------------
Grid layout info
-----------------------------------------------}
Type
  TGridInfo = record
    TotalColCount : integer;
    FixedCols     : integer;
    FixedRows     : integer;
  end;

//------------------------------------------------------
procedure Tfm_Main.tx_DragMeMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
//------------------------------------------------------
Var
  dwEffect: integer;
begin
  If Button = mbLeft then
  Begin
    If Assigned(FGWDragDemoAppInterface) then
    Begin
      ClearDeadMonitors;
      FGWDragDemoAppInterface.DoDragDrop(DROPEFFECT_COPY or DROPEFFECT_MOVE, dwEffect);
    end;
  end;
end;

//------------------------------------------------------
procedure Tfm_Main.ClearDeadMonitors;
//------------------------------------------------------
begin
  If Assigned(FGWDragDemoAppInterface) then
  Begin
    If Assigned(FGWDragDemoAppInterface.fm_OLEMonitor) then
    Begin
      FGWDragDemoAppInterface.fm_OLEMonitor.ClearDeadMonitors;
    end;
  end;
end;

//------------------------------------------------------
procedure Tfm_Main.bt_ShowMonitorClick(Sender: TObject);
//------------------------------------------------------
begin
  If Assigned(FGWDragDemoAppInterface.fm_OLEMonitor) then
  Begin
    FGWDragDemoAppInterface.fm_OLEMonitor.Show;
    FGWDragDemoAppInterface.fm_OLEMonitor.DockMe;
  end;
end;



end.
